; MORDYCONSOLE
; written 12.14.03 by morduun / morduun@hotmail.com
; simple example of integrating a console into an app

; the console include
Include "console.bb"

; generic setup stoof
Graphics3D 640, 480, 0, 2
SetBuffer BackBuffer()
Global myObj = CreateCube()
EntityColor myObj, 128, 0, 0
EntityShininess myObj, 1.0
myCam = CreateCamera()
myLight = CreateLight(2)
MoveEntity myLight, 0, 30, 0
MoveEntity myCam, 0, 1, -10
MoveMouse 320, 240
HidePointer()
myY = CreateCylinder()
ScaleEntity myY, 0.05, 1000, 0.05
EntityColor myY, 255, 255, 0
myX = CopyEntity(myY)
RotateEntity myX, 90, 0, 0
EntityColor myX, 0, 255, 255
myZ = CopyEntity(myX)
RotateEntity myZ, 0, 0, 90
EntityColor myZ, 255, 0, 255

Global XRot = 1
Global YRot = 0
Global ZRot = 0

; main loop
Repeat
	
	Cls

	If KeyHit(1)					; ESC-key console
		CLI = Not CLI				; toggle input & visibility
		FlushKeys()					; kill any still-present keyboard input
	EndIf
	
	If CLI							; if the cli's active, get input from the keybd
		myCmd$ = CONSOLE_Do(myCmd$)	

	Else							; otherwise, treat it like a game input routine
		If KeyDown(17) Then MoveEntity myCam, 0, 0, 1
		If KeyDown(30) Then MoveEntity mYCam, -1, 0, 0
		If KeyDown(31) Then MoveEntity myCam, 0, 0, -1
		If KeyDown(32) Then MoveEntity myCam, 1, 0, 0
		
	EndIf

	TurnEntity myCam, 0, -(MouseXSpeed()/2.0), 0	; simple x-only mouselook
	TurnEntity myObj, xrot, yrot, zrot				; turn the cube
	
	UpdateWorld										; updates anims and collisions (useless here)
	RenderWorld										; renders the 3d world
	
	If CLI Then CONSOLE_Display(myCmd$)		; if the cli's active, overwrite the rendered world.
	
	Flip

Forever
End


; the console lib depends on you to write this code specifically for your program.
; this is where you grab info from the command string, parse it and act on it.
; quit and default are done, as well as some basic stuff to play with the spinny cube.
; help's an example of what you'd want to do (as trust me, you'll forget even your own
; console commands after a while).
Function CONSOLE_ParseCommand(cmdString$)

	pObject$ = ParseAttr(cmdString, 1)
	pVerb$ = ParseAttr(cmdString, 2)
	pAttr$ = ParseAttr(cmdString, 3)

	Select pObject$

		Case "cube"						; creates 'cube' as a base-level console argument
			Select pVerb$
				Case "spinx"			; creates 'spinx' as a second argument under cube
					Select pAttr$
						Case "on"		; creates 'on' as a third-level argument and acts on that command
							xRot = 1
						Case "off"		; creates 'off' as a third-level argument and acts on that command
							xRot = 0
						Case "query"	; creates 'query' as a third-level argument and acts on that command
							CONSOLE_Message(("Cube XSPIN value is " + xRot), 5000)
						Default			; runs a help message to give the user values for spinx
							CONSOLE_Message(("[on] [off] [query]"), 5000)
					End Select
				Case "spiny"
					Select pAttr$
						Case "on"
							yRot = 1
						Case "off"
							yRot = 0
						Case "query"
							CONSOLE_Message(("Cube YSPIN value is " + yRot), 5000)
						Default
							CONSOLE_Message(("[on] [off] [query]"), 5000)
					End Select
				Case "spinz"
					Select pAttr$
						Case "on"
							zRot = 1
						Case "off"
							zRot = 0
						Case "query"
							CONSOLE_Message(("Cube ZSPIN value is " + zRot), 5000)
						Default
							CONSOLE_Message(("Valid values are ON, OFF and QUERY"), 5000)
					End Select

				Case "reset"			; creates 'reset' as a second-level argument under cube
					RotateEntity myObj, 0, 0, 0
					xrot = 1
					yrot = 0
					zrot = 0
				Default				; runs a help message to give the user values for cube
					CONSOLE_Message(("[spinx] [spiny] [spinz] [reset]"), 5000)
				End Select
		
	
		Case "help"
			CONSOLE_Message("[cube] [quit]", 5000)
			
		Case "quit"
			CONSOLE_Message("quit command issued.  Hit any key to exit.", 5000)
			RenderWorld
			CONSOLE_Display("quit")
			Flip
			WaitKey()
			End
			
		Default
			CONSOLE_Message("Try HELP and QUIT", 5000)
	End Select
	
End Function